#include <stdarg.h>

void* mh_ptrs[512];
int mh_numptrs=0;
bool mh_ready=false;
void* mh_malloc(int numbytes)
{
	void* ptr=malloc(numbytes);
	int i=0;
	for(i=0;i<mh_numptrs;i++)
		if(mh_ptrs[i]==NULL)
			break;
	if(i==mh_numptrs)
		mh_numptrs++;
	mh_ptrs[i]=ptr;
	return ptr;
}
void mh_free(void* ptr)
{
	free(ptr);
	for(int i=0;i<mh_numptrs;i++)
		if(mh_ptrs[i]==ptr)
		{
			mh_ptrs[i]=NULL;
			if(i==mh_numptrs-1) mh_numptrs--;
			break;
		}
	return;
}
void mh_cleanup()
{
	for(int i=0;i<mh_numptrs;i++)
		free(mh_ptrs[i]);
	mh_numptrs=0;
}

